function getCsrfToken() {
    return $('input[name="csrf_token"]').val();
}

var handleEditableFieldConstruct = function () {
    $.fn.editable.defaults.mode = 'inline';
    $.fn.editable.defaults.inputclass = 'form-control input-sm';
    $.fn.editable.defaults.ajaxOptions = { type: "POST" };
    $.fn.editable.defaults.params = function (params) {
        params['edit_lang'] = 1;
        params['csrf_token'] = getCsrfToken();
        return params;
    };

    editableIds.forEach(function (id) {
        $('#' + id).editable({
            url: './includes/post_ibosol_languages.php',
            type: 'text',
            pk: function () {
                return $(this).data('pk');
            },
            name: function () {
                return $(this).data('name');
            },
            csrf_token: getCsrfToken()
        });
    });
    
};

var FormEditable = function () {
    "use strict";
    return {
        init: function () {
            handleEditableFieldConstruct();
        }
    };
}();

$(document).ready(function () {
    FormEditable.init();

    $("#lang_select").on("change", function () {
        var language = $(this).val();
        $.ajax({
            url: "./includes/get_ibosol_languages.php",
            type: "POST",
            data: {
                "language-select": language,
                "csrf_token": getCsrfToken()
            },
            success: function (data) {
                $("#table-content").html(data);
                FormEditable.init();
            },
            error: function (xhr, status, error) {
                console.error("AJAX request failed: " + error);
            }
        });
    });
});
