function getCsrfToken() {
    return $('input[name="csrf_token"]').val();
}

$(function () {
    $("#post_service").on("submit", function (e) {
        e.preventDefault();
        var formData = new FormData(this);
        formData.append('post_service', '1');
        formData.append('csrf_token', getCsrfToken());
        $.ajax({
            type: "POST",
            url: "./includes/post_ibosol_services.php",
            data: formData,
            processData: false,
            contentType: false,
            success: function () {
                location.reload();
            },
        });
    });

    $("#post_client").on("submit", function (e) {
        e.preventDefault();
        var formData = new FormData(this);
        formData.append('post_client', '1');
        formData.append('csrf_token', getCsrfToken());
        $.ajax({
            type: "POST",
            url: "./includes/post_ibosol_services.php",
            data: formData,
            processData: false,
            contentType: false,
            success: function () {
                location.reload();
            },
        });
    });

    $("#post_active_code").on("submit", function (e) {
        e.preventDefault();
        var formData = new FormData(this);
        formData.append('post_active_code', '1');
        formData.append('csrf_token', getCsrfToken());
        $.ajax({
            type: "POST",
            url: "./includes/post_ibosol_services.php",
            data: formData,
            processData: false,
            contentType: false,
            success: function () {
                location.reload();
            },
        });
    });

    $(document).on('keyup change', '#mac_address', function () {
        makeMacAddressFormat(this);
    });

    function makeMacAddressFormat(targetElement) {
        var macLength = $(targetElement).data('mac-length');

        if (!macLength || isNaN(macLength)) {
            macLength = 12;
        }

        var origin_value = $(targetElement).val().replace(/[^0-9A-Fa-f]/g, '').toUpperCase();
        var formatted_value = '';
        for (var i = 0; i < origin_value.length; i++) {
            if (i > 0 && i % 2 === 0) {
                formatted_value += ':';
            }
            formatted_value += origin_value[i];
            if (formatted_value.length >= (macLength + (macLength / 2 - 1))) {
                break;
            }
        }
        $(targetElement).val(formatted_value);
    }
});

function deleteService(service_id) {
    if (confirm("Are you sure you want to delete this service?\n\n" +
        "Warning: Deleting a service will remove all users tied to this service. " +
        "It is encouraged to change the service of the users before removing the service from the panel.")) {
        $.ajax({
            type: "POST",
            url: "./includes/post_ibosol_services.php",
            data: {
                delete_service: 1,
                service_id: service_id,
                csrf_token: getCsrfToken()
            },
            success: function () {
                location.reload();
            },
        });
    }
}

function deleteClient(id) {
    if (confirm("Are you sure you want to delete this client?")) {
        $.ajax({
            type: "POST",
            url: "./includes/post_ibosol_services.php",
            data: {
                delete_client: 1,
                id: id,
                csrf_token: getCsrfToken()
            },
            success: function () {
                location.reload();
            },
        });
    }
}

function banClient(id) {
    if (confirm("Are you sure you want to ban this client?")) {
        $.ajax({
            type: "POST",
            url: "./includes/post_ibosol_services.php",
            data: {
                ban_client: 1,
                id: id,
                csrf_token: getCsrfToken()
            },
            success: function () {
                location.reload();
            },
        });
    }
}

function unbanClient(id) {
    if (confirm("Are you sure you want to unban this client?")) {
        $.ajax({
            type: "POST",
            url: "./includes/post_ibosol_services.php",
            data: {
                unban_client: 1,
                id: id,
                csrf_token: getCsrfToken()
            },
            success: function () {
                location.reload();
            },
        });
    }
}

function deleteActiveCode(id) {
    if (confirm("Are you sure you want to delete this active code?")) {
        $.ajax({
            type: "POST",
            url: "./includes/post_ibosol_services.php",
            data: {
                delete_active_code: 1,
                id: id,
                csrf_token: getCsrfToken()
            },
            success: function () {
                location.reload();
            },
        });
    }
}

function deactivateActiveCode(id) {
    if (confirm("Are you sure you want to deactivate this active code?")) {
        $.ajax({
            type: "POST",
            url: "./includes/post_ibosol_services.php",
            data: {
                deactivate_active_code: 1,
                id: id,
                csrf_token: getCsrfToken()
            },
            success: function () {
                location.reload();
            },
        });
    }
}

function activateActiveCode(id) {
    if (confirm("Are you sure you want to activate this active code?")) {
        $.ajax({
            type: "POST",
            url: "./includes/post_ibosol_services.php",
            data: {
                activate_active_code: 1,
                id: id,
                csrf_token: getCsrfToken()
            },
            success: function () {
                location.reload();
            },
        });
    }
}

function editActiveCode(code, service_id, username, password, status) {
    $("#ac_code").val(code);
    $("#ac_service_id").val(service_id);
    $("#ac_username").val(username);
    $("#ac_password").val(password);
    $("#ac_status").val(status);
}

function editService(serviceName, serviceUrl) {
    $("#name").val(serviceName);
    $("#url").val(serviceUrl);
}

function editClient(mac_address, device_key, service_id, username, password, parent_control, status) {
    $("#mac_address").val(mac_address);
    $("#device_key").val(device_key);
    $("#service_id").val(service_id);
    $("#username").val(username);
    $("#password").val(password);
    $("#parent_control").val(parent_control);
    $("#status").val(status);
}